require "import"
import "android.widget.*"
import "com.androlua.*"

-- tabla de preguntas y respuestas
preguntas = {
{pregunta = "6+6=?", respuesta = 12, score = 10},
    {pregunta = "6-1=?", respuesta = 5, score = 10},
    {pregunta = "21*3=?", respuesta = 63, score = 10},
    {pregunta = "6*3-8=?", respuesta = 10, score = 10},
    {pregunta = "1*2*3*4*5=?", respuesta = 120, score = 10},
    {pregunta = "24*4/4=?", respuesta = 24, score = 10},
    {pregunta = "140-16-6-6=?", respuesta = 112, score = 10},
    {pregunta = "you have 16 coines in your hand. but, you have 3 friends on with you. so, how will you devide  in to them?", respuesta = 5.3, score = 10},
    {pregunta = "you are studying saint joshep school. there are 100 people are staying there. they devided in to 6 section. in the 12standard, 6 people are studying. in the 11standard they have 6, in the 10standard 15 people there. in the ninethstandard, 15 people are there. so, how much person it didint mention from the list and multiplai  by 2?", respuesta = 116, score = 10},
    {pregunta = "hello, in this question, you are going find percentage following question.  2000%25-100, you want to find 25 % for given number and miness 100 so, what is the answer?", respuesta = 400, score = 10},
    {pregunta = "you are working as a HR  manager. you are maintaining 3 sections. in each section, they are working for 180 people. so, the question is: 180*3, then find 5%. then miness by 10.", respuesta = 17, score = 10},
    {pregunta = "find the missing number: 3, 6, 9, 15. ", respuesta = 12, score = 10},
    {pregunta = "again the same question. but, this time just little harder. find the number: 2, 4, 8, 16, 64. ", respuesta = 32, score = 10},
    {pregunta = "find the disending auder: 10000, 9400, 8800, 8200, 7600 then?", respuesta = 7000, score = 10},
    {pregunta = " same question. but this is diffrant. you will find yourself. 10000, 20001, 30002, 40003. then?", respuesta = 50004, score = 10},
}

-- tabla de preguntas realizadas
preguntasRealizadas = {}

-- contador de preguntas respondidas correctamente
preguntasCorrectas = 0

-- puntuación total
puntuacionTotal = 0

-- variable para el tiempo inicial del juego
tiempoInicial = os.time()

-- función para verificar si se han acumulado 150 puntos
function seAcumularon150Puntos()
    return puntuacionTotal >= 150
end

-- función para mostrar el marcador
function mostrarMarcador()
    local tiempoTranscurrido = os.time() - tiempoInicial
    service.asyncSpeak(string.format("Tiempo transcurrido: %d segundos. Puntuación total: %d puntos.", tiempoTranscurrido, puntuacionTotal))
end

-- función para mostrar una pregunta
function mostrarPregunta()
    -- obtener una pregunta aleatoria que no se haya realizado antes
    local preguntaActual
    repeat
        preguntaActual = preguntas[math.random(1, #preguntas)]
    until not preguntasRealizadas[preguntaActual]

    -- agregar la pregunta actual a la tabla de preguntas realizadas
    preguntasRealizadas[preguntaActual] = true
    
    -- crear el layout de la pregunta
    layout = {
        LinearLayout;
        orientation = "vertical";
        {
            TextView,
            text = preguntaActual.pregunta,
            layout_gravity = "center_horizontal",
            textSize = "20sp",
            paddingTop = "20dp",
            paddingBottom = "20dp",
        };
        {
            EditText,
            id = "respuesta",
            inputType = "text",
            layout_width = "match_parent",
            layout_height = "wrap_content",
        };
        {
            Button,
            text = "ok",
            onClick = function()
                -- obtener la respuesta ingresada por el usuario
                local respuesta = respuesta.text
                
                -- verificar si la respuesta es correcta
                if tonumber(respuesta) == tonumber(preguntaActual.respuesta) then
                    preguntasCorrectas = preguntasCorrectas + 1
                    puntuacionTotal = puntuacionTotal + preguntaActual.score
                    
                    -- mostrar mensaje de respuesta correcta y score actualizado
                    service.asyncSpeak("¡Respuesta correcta!")
                    dlg.dismiss()

                    -- verificar si se han acumulado 20 puntos
                    if seAcumularon150Puntos() then
                        -- mostrar el marcador
                        mostrarMarcador()
                    else
                        -- mostrar otra pregunta
                        mostrarPregunta()
                    end
                else
                    -- mostrar mensaje de respuesta incorrecta
                    service.asyncSpeak("wrong answer please try again")
                end
            end,
        };
        {
            Button,
            text = "close",
            onClick = function()
                -- cerrar la sintaxis
                dlg.dismiss()
            end,
        };
    }

    -- mostrar el layout de la pregunta
    dlg = LuaDialog(service)
    dlg.View = loadlayout(layout)
    dlg.show()
end




-- función para mostrar el cuadro de resultados
function mostrarResultados()
    -- crear el layout del cuadro de diálogo
    local result_layout = {
        LinearLayout;
        orientation = "vertical";
        {
            TextView,
            text = "Result:",
            textSize = "20sp",
            layout_gravity = "center_horizontal",
            paddingTop = "20dp",
            paddingBottom = "20dp",
        };
        {
            TextView,


            layout_gravity = "center_horizontal",
            textSize = "18sp",
            paddingBottom = "10dp",
        };
        {
            TextView,
            text = string.format("correct answer: %d", preguntasCorrectas),
            layout_gravity = "center_horizontal",
            textSize = "18sp",
            paddingBottom = "10dp",
        };
        {
            TextView,
            text = string.format("total score: %d", puntuacionTotal),
            layout_gravity = "center_horizontal",
            textSize = "18sp",
            paddingBottom = "20dp",
        };
        {
            Button,
            text = "close",
            onClick = function()
                -- cerrar el cuadro de diálogo
                result_dlg.dismiss()
            end,
        };
    }

    -- crear el cuadro de diálogo
    result_dlg = LuaDialog(service)
    result_dlg.View = loadlayout(result_layout)
    result_dlg.show()
end

-- función para mostrar el marcador
function mostrarMarcador()
    local tiempoTranscurrido = os.time() - tiempoInicial
    service.asyncSpeak(string.format("Tiempo transcurrido: %d segundos. Puntuación total: %d puntos.", tiempoTranscurrido, puntuacionTotal))

    -- mostrar el cuadro de resultados
    mostrarResultados()
end

-- iniciar el juego mostrando la primera pregunta
mostrarPregunta()
return true